/*
 * ARM specific SMP header, this contains our implementation
 * details.
 */
#ifndef __ASMARM_SMP_PLAT_H
#define __ASMARM_SMP_PLAT_H

#include <asm/cputype.h>

/* all SMP configurations have the extended CPUID registers */
static inline int tlb_ops_need_broadcast(void)
{
	return ((read_cpuid_ext(CPUID_EXT_MMFR3) >> 12) & 0xf) < 2;
}

#ifdef CONFIG_PVC_CPU_LOGICAL_MAP
/*
 * Logical CPU mapping.
 */
extern int __cpu_logical_map[];
#define cpu_logical_map(cpu)	__cpu_logical_map[cpu]

extern int gic_cpuif_logical_map[];
#define cpuif_logical_map(cpu)	gic_cpuif_logical_map[cpu]

#endif /* CONFIG_PVC_CPU_LOGICAL_MAP */

#endif
