#ifndef _xdmac_drv_h_included_
#define _xdmac_drv_h_included_

/* ============================================================= */
/*    include files                                              */
/* ============================================================= */
#include <linux/ioctl.h>
#include "xdmac_ioctl.h"

/* ============================================================= */
/*    macros                                                     */
/* ============================================================= */


/* ============================================================= */
/*    macros (return)                                            */
/* ============================================================= */
#define XDMAC_OK  0
#define XDMAC_NG -1


/* ============================================================= */
/*    structures, enums                                          */
/* ============================================================= */
typedef enum {
	xdmac_ch0 = 0,
	xdmac_ch1 = 1,
	xdmac_ch2 = 2,
	xdmac_ch3 = 3,
	xdmac_ch4 = 4,
	xdmac_ch5 = 5
} EXdmaCh;

/* ============================================================= */
/*    API prototype definitions                                  */
/* ============================================================= */
int iXdmaInit(EXdmaCh);
int iXdmaStart(EXdmaCh, SDmaParam *);
int iXdmaGet(EXdmaCh, SDmaStat *);
int iXdmaCfg(SDmaCfg *);
int iXdmaDcinv(SDmaDstInfo *);

/* ============================================================= */
/*    API prototype definitions(internal use only)               */
/* ============================================================= */
int iXdmaRegRead(unsigned int);
int iXdmaRegWrite(unsigned int, unsigned int);

#endif

