/*
 * arch/arm/mach-pvc01s/include/mach/pvc01s.h
 *
 * Copyright (c) 2012 Panasonic, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#ifndef __ASM_ARCH_PVCSD_H
#define __ASM_ARCH_PVCSD_H

#include <linux/autoconf.h>
#if defined(CONFIG_PVC01S_USE_SD0)
#define PVCSD_USE_SD0
#elif defined(CONFIG_PVC01S_USE_SD1)
#define PVCSD_USE_SD1
#elif defined(CONFIG_PVC01S_USE_SD2)
#define PVCSD_USE_SD2
#endif



#define PVCSD_SEQ_BASE		0x100A0000

#define PVCSD_SEQ_PCLK		0x02b4
#define PVCSD_SEQ_PRESET	0x0338
#define PVCSD_SEQ_CLOCK		0x03c8
#define PVCSD_SEQ_SYSRESET	0x02dc
#define PVCSD_SEQ_HRESET_SD0	0x02ec
#define PVCSD_SEQ_HRESET_SD1	0x02f0
#define PVCSD_SEQ_HRESET_SD2	0x02f4


#define PVCSD_IOB_BASE		0x12000000
#define PVCSD_IOBRESET		0x0000
#define PVCSD_IOBCLKEN		0x0004
#define PVCSD_IOBDMCMIR		0x0010
#define PVCSD_IOBDMCMIE		0x0014
#define PVCSD_IOBDMCMID		0x0018

#define PVCSD_IOBPERIMIR	0x0050
#define PVCSD_IOBPERIMIE	0x0054
#define PVCSD_IOBPERIMID	0x0058

#define PVCSD_IOBIFSEL		0x0104
#define PVCSD_CDXST_GCTLENB	0x107F4

#define PVCSD_RESETSD2		14
#define PVCSD_RESETSD1		13
#define PVCSD_RESETDMAC 	9
#define PVCSD_RESETPDIF 	8
#define PVCSD_RESETDMAC_DLNA 	6
#define PVCSD_RESETUSB		4
#define PVCSD_RESETUSB_DMA 	3
#define PVCSD_RESETSD0		0

#define PVCSD_CLKEN_SD2DET	31		
#define PVCSD_ICLKSEL_SD2	29
#define PVCSD_CLKEN_SD1DET	27
#define PVCSD_ICLKSEL_SD1	25
#define PVCSD_ICLKSEL_SD0	17
#define PVCSD_CLKEN_SD2		14
#define PVCSD_CLKEN_SD1		13
#define PVCSD_CLKEN_DMC		9
#define PVCSD_CLKEN_PD		8
#define PVCSD_CLKEN_DLDMC	6
#define PVCSD_CLKEN_SD0DET	5
#define PVCSD_CLKEN_USB		4
#define PVCSD_CLKEN_USB_DMA	3
#define PVCSD_CLKEN_ATA		1
#define PVCSD_CLKEN_SD0		0

#define PVCSD_DMAC_RB2IR	10
#define PVCSD_DMAC_RB1IR	9
#define PVCSD_DMAC_RB0IR	8
#define PVCSD_DMAC_CH4IR	4
#define PVCSD_DMAC_CH3IR	3
#define PVCSD_DMAC_CH2IR	2
#define PVCSD_DMAC_CH1IR	1
#define PVCSD_DMAC_CH0IR	0

#define PVCSD_DMAC_RB2IE	10
#define PVCSD_DMAC_RB1IE	9
#define PVCSD_DMAC_RB0IE	8
#define PVCSD_DMAC_CH4IE	4
#define PVCSD_DMAC_CH3IE	3
#define PVCSD_DMAC_CH2IE	2
#define PVCSD_DMAC_CH1IE	1
#define PVCSD_DMAC_CH0IE	0

#define PVCSD_DMAC_RB2ID	10
#define PVCSD_DMAC_RB1ID	9
#define PVCSD_DMAC_RB0ID	8
#define PVCSD_DMAC_CH4ID	4
#define PVCSD_DMAC_CH3ID	3
#define PVCSD_DMAC_CH2ID	2
#define PVCSD_DMAC_CH1ID	1
#define PVCSD_DMAC_CH0ID	0

#define PVCSD_IF_SD2IE		11
#define PVCSD_IF_SDIO2IE	10
#define PVCSD_IF_SD1IE		9
#define PVCSD_IF_SDIO1IE	8
#define PVCSD_IF_USBIE		4
#define PVCSD_IF_ATAIE		2
#define PVCSD_IF_SD0IE		1
#define PVCSD_IF_SDIO0IE	0

#define PVCSD_IF_SD2ID		11
#define PVCSD_IF_SDIO2ID	10
#define PVCSD_IF_SD1ID		9
#define PVCSD_IF_SDIO1ID	8
#define PVCSD_IF_USBID		4
#define PVCSD_IF_ATAID		2
#define PVCSD_IF_SD0ID		1
#define PVCSD_IF_SDIO0ID	0

#define PVCSD_IOBSD1SEL	1


#define PVCSD_AREA0_BASE	0x12010000
#define PVCSD_AREA1_BASE	0x12010080
#define PVCSD_AREA3_BASE	0x12010400
#define PVCSD_AREA4_BASE	0x12010340
#define PVCSD_SRAM_CTL_BASE 	0x120B0000


#define PVCSD_CDXST_STRT	(0)
#define PVCSD_CDXST_PERFCNFG	(0x0008)
#define PVCSD_CDXST_STAT0	(0x0020)
#define PVCSD_CDXST_RBFLUSH0	(0x0040)
#define PVCSD_CDXST_PARTRESET0	(0x0050)
#define PVCSD_CDXST_MONNUM	(0x0058)
#define PVCSD_CDXST_CH0CTRL2	(0x0084)
#define PVCSD_CDXST_CH0STAT	(0x0090)
#define PVCSD_CDXST_CH0IR	(0x0094)
#define PVCSD_CDXST_CH0IE	(0x0098)
#define PVCSD_CDXST_CH0ID	(0x009C)
#define PVCSD_CDXST_CH0SRCAMODE	(0x00A0)
#define PVCSD_CDXST_CH0DSTAMODE	(0x00A4)
#define PVCSD_CDXST_CH0SRCSTRTA	(0x00A8)
#define PVCSD_CDXST_CH0DSTSTRTA	(0x00AC)
#define PVCSD_CDXST_CH0SIZE	(0x00B0)
#define PVCSD_CDXST_CH1CTRL2	(0x00C4)
#define PVCSD_CDXST_CH1STAT	(0x00D0)
#define PVCSD_CDXST_CH1IR	(0x00D4)
#define PVCSD_CDXST_CH1IE	(0x00D8)
#define PVCSD_CDXST_CH1ID	(0x00DC)
#define PVCSD_CDXST_CH1SRCAMODE	(0x00E0)
#define PVCSD_CDXST_CH1DSTAMODE	(0x00E4)
#define PVCSD_CDXST_CH1SRCSTRTA	(0x00E8)
#define PVCSD_CDXST_CH1DSTSTRTA	(0x00EC)
#define PVCSD_CDXST_CH1SIZE	(0x00F0)
#define PVCSD_CDXST_CH2CTRL2	(0x0104)
#define PVCSD_CDXST_CH2STAT	(0x0110)
#define PVCSD_CDXST_CH2IR	(0x0114)
#define PVCSD_CDXST_CH2IE	(0x0118)
#define PVCSD_CDXST_CH2ID	(0x011C)
#define PVCSD_CDXST_CH2SRCAMODE	(0x0120)
#define PVCSD_CDXST_CH2DSTAMODE	(0x0124)
#define PVCSD_CDXST_CH2SRCSTRTA	(0x0128)
#define PVCSD_CDXST_CH2DSTSTRTA	(0x012C)
#define PVCSD_CDXST_CH2SIZE	(0x0130)

#define PVCSD_CDXST_CH3CTRL2	(0x0144)
#define PVCSD_CDXST_CH3STAT	(0x0150)
#define PVCSD_CDXST_CH3IR	(0x0154)
#define PVCSD_CDXST_CH3IE	(0x0158)
#define PVCSD_CDXST_CH3ID	(0x015C)
#define PVCSD_CDXST_CH3SRCAMODE	(0x0160)
#define PVCSD_CDXST_CH3DSTAMODE	(0x0164)
#define PVCSD_CDXST_CH3SRCSTRTA	(0x0168)
#define PVCSD_CDXST_CH3DSTSTRTA	(0x016C)
#define PVCSD_CDXST_CH3SIZE	(0x0170)

#define PVCSD_CDXST_CH4CTRL2	(0x0184)
#define PVCSD_CDXST_CH4STAT	(0x0190)
#define PVCSD_CDXST_CH4IR	(0x0194)
#define PVCSD_CDXST_CH4IE	(0x0198)
#define PVCSD_CDXST_CH4ID	(0x019C)
#define PVCSD_CDXST_CH4SRCAMODE	(0x01A0)
#define PVCSD_CDXST_CH4DSTAMODE	(0x01A4)
#define PVCSD_CDXST_CH4SRCSTRTA	(0x01A8)
#define PVCSD_CDXST_CH4DSTSTRTA	(0x01AC)
#define PVCSD_CDXST_CH4SIZE	(0x01B0)


#define PVCSD_CDXST_RB0BGNADRS		(0x0400)
#define PVCSD_CDXST_RB0ENDADRS		(0x0404)
#define PVCSD_CDXST_RB0BTH		(0x0408)
#define PVCSD_CDXST_RB0RTH		(0x040C)
#define PVCSD_CDXST_RB0STAT		(0x0410)
#define PVCSD_CDXST_RB0IR		(0x0414)
#define PVCSD_CDXST_RB0IE		(0x0418)
#define PVCSD_CDXST_RB0ID		(0x041C)
#define PVCSD_CDXST_RB0RDPTR		(0x0420)
#define PVCSD_CDXST_RB0WRPTR		(0x0428)
#define PVCSD_CDXST_RB0CNFG		(0x0430)
#define PVCSD_CDXST_RB0PTRCTRL		(0x0434)

#define PVCSD_CDXST_RB1BGNADRS		(0x0440)
#define PVCSD_CDXST_RB1ENDADRS		(0x0444)
#define PVCSD_CDXST_RB1BTH		(0x0448)
#define PVCSD_CDXST_RB1RTH		(0x044C)
#define PVCSD_CDXST_RB1STAT		(0x0450)
#define PVCSD_CDXST_RB1IR		(0x0454)
#define PVCSD_CDXST_RB1IE		(0x0458)
#define PVCSD_CDXST_RB1ID		(0x045C)
#define PVCSD_CDXST_RB1RDPTR		(0x0460)
#define PVCSD_CDXST_RB1WRPTR		(0x0468)
#define PVCSD_CDXST_RB1CNFG		(0x0470)
#define PVCSD_CDXST_RB1PTRCTRL		(0x0474)

#define PVCSD_CDXST_RB2BGNADRS		(0x0480)
#define PVCSD_CDXST_RB2ENDADRS		(0x0484)
#define PVCSD_CDXST_RB2BTH		(0x0488)
#define PVCSD_CDXST_RB2RTH		(0x048C)
#define PVCSD_CDXST_RB2STAT		(0x0490)
#define PVCSD_CDXST_RB2IR		(0x0494)
#define PVCSD_CDXST_RB2IE		(0x0498)
#define PVCSD_CDXST_RB2ID		(0x049C)
#define PVCSD_CDXST_RB2RDPTR		(0x04A0)
#define PVCSD_CDXST_RB2WRPTR		(0x04A8)
#define PVCSD_CDXST_RB2CNFG		(0x04B0)
#define PVCSD_CDXST_RB2PTRCTRL		(0x04B4)

#define PVCSD_CDXST_RC0MSKCYC		(0x0340)
#define PVCSD_CDXST_RC1MSKCYC		(0x0350)
#define PVCSD_CDXST_RC2MSKCYC		(0x0360)

#define PVCSD_SD0_BASE			(PVCSD_IOB_BASE | 0x20000)
#define PVCSD_SD1_BASE			(PVCSD_IOB_BASE | 0x70000)
#define PVCSD_SD2_BASE			(PVCSD_IOB_BASE | 0xA0000)

#if defined(PVCSD_USE_SD0)
#define PVCSD_SDX_BASE			PVCSD_SD0_BASE
#elif defined(PVCSD_USE_SD1)
#define PVCSD_SDX_BASE			PVCSD_SD1_BASE
#elif defined(PVCSD_USE_SD2)
#define PVCSD_SDX_BASE			PVCSD_SD2_BASE
#endif


#define PVCSD_CMD		0x00
#define PVCSD_PORTSEL		0x04
#define PVCSD_ARG0		0x08
#define PVCSD_ARG1		0x0C
#define PVCSD_STOP		0x10
#define PVCSD_SECCNT		0x14
#define PVCSD_RSP0		0x18
#define PVCSD_RSP1		0x1C
#define PVCSD_RSP2		0x20
#define PVCSD_RSP3		0x24
#define PVCSD_RSP4		0x28
#define PVCSD_RSP5		0x2C
#define PVCSD_RSP6		0x30
#define PVCSD_RSP7		0x34
#define PVCSD_INFO1		0x38
#define PVCSD_INFO2		0x3C
#define PVCSD_INFO1_MASK	0x40
#define PVCSD_INFO2_MASK	0x44
#define PVCSD_CLK_CTRL		0x48
#define PVCSD_SIZE		0x4C
#define PVCSD_OPTION		0x50
#define PVCSD_ERR_STS1		0x58
#define PVCSD_ERR_STS2		0x5C
#define PVCSD_BUF0		0x60
#define PVCSD_SDIO_MODE		0x68
#define PVCSD_SDIO_INFO1	0x6C
#define PVCSD_SDIO_INFO1_MASK	0x70
#define PVCSD_CC_EXT_MODE	0x1B0
#define PVCSD_SOFT_RST		0x1C0
#define PVCSD_PWR		0x1E4
#define PVCSD_EXT_SDIO		0x1E8
#define PVCSD_EXT_WP		0x1EC
#define PVCSD_EXT_CD		0x1F0
#define PVCSD_EXT_CD_DAT3	0x1F4
#define PVCSD_EXT_CD_MASK	0x1F8
#define PVCSD_EXT_CD_DAT3_MASK	0x1FC


#define PVCSD_CLOCKRATE_MAX	43875000

struct pvcsdio_platform_data {
	unsigned int clock;
};

#endif
