/*
 * arch/arm/mach-pvc01s/include/mach/uncompress.h
 *
 * Copyright (c) 2012 Panasonic, Inc
 *
 * based on : arm versatile
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#ifndef __ASM_ARCH_UNCOMPRESS_H
#define __ASM_ARCH_UNCOMPRESS_H

#include <linux/autoconf.h>

//	UART1		addr : 0xfff21000
#define AMBA_UART_DR	(*(volatile unsigned char *)0xfff21000)
#define AMBA_UART_LCRH	(*(volatile unsigned char *)0xfff2102c)
#define AMBA_UART_CR	(*(volatile unsigned char *)0xfff21030)
#define AMBA_UART_FR	(*(volatile unsigned char *)0xfff21018)


/*
 * This does not append a newline
 */
static inline void putc(int c)
{
#if defined(CONFIG_SERIAL_AMBA_PL011)
	while (AMBA_UART_FR & (1 << 5))
		barrier();

	AMBA_UART_DR = c;
#endif
}

static inline void flush(void)
{
#if defined(CONFIG_SERIAL_AMBA_PL011)
	while (AMBA_UART_FR & (1 << 3))
		barrier();
#endif
}

/*
 * nothing to do
 */
#define arch_decomp_setup()
#define arch_decomp_wdog()

#endif /* __ASM_ARCH_UNCOMPRESS_H */
