#ifndef __ASM_ARCH_CORE_H
#define __ASM_ARCH_CORE_H

#define AMBA_APB_DEVICE(name, busid, id, base, irqs, data)	\
	struct amba_device name##_device = {			\
	.dev 		 = {					\
		.coherent_dma_mask = 0,				\
		.init_name = busid,				\
		.platform_data = data,				\
	},							\
	.res		 = {					\
		.start = (base),				\
		.end = (base) + SZ_4K - 1,			\
		.flags = IORESOURCE_MEM,			\
	},							\
	.irq = irqs,						\
	.periphid = id,						\
}


#ifdef CONFIG_SMP
extern void board_smp_init_cpus(void);
extern void board_smp_prepare_cpus(unsigned int max_cpus);
#endif

#endif /* __ASM_ARCH_CORE_H */
