/*
 * arch/arm/mach-pvc01s/include/mach/pvc01v.h
 *
 * Copyright (c) 2012 Panasonic, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#ifndef __ASM_ARCH_PVC01V_H
#define __ASM_ARCH_PVC01V_H

#include <linux/autoconf.h>

#if defined(CONFIG_ARCH_UNIPHIER) || defined(CONFIG_ARCH_PVC02V)

#if defined(CONFIG_ARCH_UNIPHIER)
#define PVC01S_SDIO_V8FHD
#elif defined(CONFIG_ARCH_PVC02V)
#define PVC01_SDIO_V9AHD
#endif

#ifdef PVC01_SDIO_V9AHD

#define PVCSD_SDTOP_BASE_CH0	0x7C300000
#define PVCSD_SDTOP_BASE_CH1	0x7C310000
#define PVCSD_SDTOP_BASE_CH2	0x7C320000
#define PVCSD_SDTOP_BASE_CH3	0x7C330000

#define PVCSD_SDX_BASE_CH0	(PVCSD_SDTOP_BASE_CH0)
#define PVCSD_SDX_BASE_CH1	(PVCSD_SDTOP_BASE_CH1)
#define PVCSD_SDX_BASE_CH2	(PVCSD_SDTOP_BASE_CH2)
#define PVCSD_SDX_BASE_CH3	(PVCSD_SDTOP_BASE_CH3)

#define PVCSD_USE_PORTSEL_0	0x0000
#define PVCSD_USE_PORTSEL_1	0x0001
#define PVCSD_USE_PORTSEL_2	0x0002
#define PVCSD_USE_PORTSEL_3	0x0003

/* index of IORESOURCE_IRQ in pvcsdio_resources[] */
#define PVCSD_IORSC_IDX_IRQ_SD_CH0	0
#define PVCSD_IORSC_IDX_IRQ_SDIO_CH0	1
#define PVCSD_IORSC_IDX_IRQ_SD_CH1	2
#define PVCSD_IORSC_IDX_IRQ_SDIO_CH1	3
#define PVCSD_IORSC_IDX_IRQ_SD_CH2	4
#define PVCSD_IORSC_IDX_IRQ_SDIO_CH2	5
#define PVCSD_IORSC_IDX_IRQ_SD_CH3	6
#define PVCSD_IORSC_IDX_IRQ_SDIO_CH3	7

/* index of IORESOURCE_MEM in pvcsdio_resources[] */
#define PVCSD_IORSC_IDX_MEM_SDXBASE_CH0	0
#define PVCSD_IORSC_IDX_MEM_SDXBASE_CH1	1
#define PVCSD_IORSC_IDX_MEM_SDXBASE_CH2	2
#define PVCSD_IORSC_IDX_MEM_SDXBASE_CH3	3

enum pvcsd_info_ch_index {
	PVCSD_INFO_CH_IORSC_IRQ_SD	= 0,
	PVCSD_INFO_CH_IORSC_IRQ_SDIO,
	PVCSD_INFO_CH_IORSC_MEM_SDXBASE,
};

enum pvcsd_info_port_index {
	PVCSD_INFO_PORT_USE_PORTSEL	= 0,
};

#define PVCSD_CMD				0x000
#define PVCSD_PORTSEL			0x008
#define PVCSD_ARG0				0x010
#define PVCSD_ARG1				0x018
#define PVCSD_STOP				0x020
#define PVCSD_SECCNT			0x028
#define PVCSD_RSP0				0x030
#define PVCSD_RSP1				0x038
#define PVCSD_RSP2				0x040
#define PVCSD_RSP3				0x048
#define PVCSD_RSP4				0x050
#define PVCSD_RSP5				0x058
#define PVCSD_RSP6				0x060
#define PVCSD_RSP7				0x068
#define PVCSD_INFO1				0x070
#define PVCSD_INFO2				0x078
#define PVCSD_INFO1_MASK		0x080
#define PVCSD_INFO2_MASK		0x088
#define PVCSD_CLK_CTRL			0x090
#define PVCSD_SIZE				0x098
#define PVCSD_OPTION			0x0A0
#define PVCSD_ERR_STS1			0x0B0
#define PVCSD_ERR_STS2			0x0B8
#define PVCSD_BUF0				0x0C0
#define PVCSD_SDIO_MODE			0x0D0
#define PVCSD_SDIO_INFO1		0x0D8
#define PVCSD_SDIO_INFO1_MASK	0x0E0
#define PVCSD_CC_EXT_MODE		0x360
#define PVCSD_SOFT_RST			0x380
#define PVCSD_VERSION			0x388
#define PVCSD_HOST_MODE			0x390
#define PVCSD_SD_STATUS 		0x3C8
#define PVCSD_EXT_SDIO			0x3D0
#define PVCSD_EXT_WP			0x3D8
#define PVCSD_EXT_CD			0x3E0
#define PVCSD_EXT_CD_DAT3		0x3E8
#define PVCSD_EXT_CD_MASK		0x3F0
#define PVCSD_EXT_CD_DAT3_MASK	0x3F8

#define PVCSD_HOST_MODE_WMODE	0x000

#else /* ifdef PVC01_SDIO_V9AHD */

#define PVCSD_SDTOP_BASE_CH0	0x9C008000
#define PVCSD_SDTOP_BASE_CH1	0x9C001000
#define PVCSD_SDX_BASE_CH0	(PVCSD_SDTOP_BASE_CH0)
#define PVCSD_SDX_BASE_CH1	(PVCSD_SDTOP_BASE_CH1)

#define PVCSD_USE_PORTSEL_0	0x0000
#define PVCSD_USE_PORTSEL_1	0x0001
#define PVCSD_USE_PORTSEL_2	0x0002
#define PVCSD_USE_PORTSEL_3	0x0003

/* index of IORESOURCE_IRQ in pvcsdio_resources[] */
#define PVCSD_IORSC_IDX_IRQ_SD_CH0	0
#define PVCSD_IORSC_IDX_IRQ_SDIO_CH0	1
#define PVCSD_IORSC_IDX_IRQ_SD_CH1	2
#define PVCSD_IORSC_IDX_IRQ_SDIO_CH1	3

/* index of IORESOURCE_MEM in pvcsdio_resources[] */
#define PVCSD_IORSC_IDX_MEM_SDXBASE_CH0	0
#define PVCSD_IORSC_IDX_MEM_SDXBASE_CH1	1

enum pvcsd_info_ch_index {
	PVCSD_INFO_CH_IORSC_IRQ_SD	= 0,
	PVCSD_INFO_CH_IORSC_IRQ_SDIO,
	PVCSD_INFO_CH_IORSC_MEM_SDXBASE,
};

enum pvcsd_info_port_index {
	PVCSD_INFO_PORT_USE_PORTSEL	= 0,
};

#define PVCSD_DMA_MODE_DIR	0x0001
#define PVCSD_DMA_START		0x0001
#define PVCSD_DMA_END		0x0001
#define PVCSD_DMA_STATUS_START	0x0001
#define PVCSD_DMA_STATUS_CANCEL	0x0002
#define PVCSD_DMA_STATUS_END	0x0004
#define PVCSD_DMA_STATUS_HALT	0x0008
#define PVCSD_SET_IRQ2			0x0001

#define PVCSD_SDTOP_DMA_MODE			0x0000
#define PVCSD_SDTOP_DMA_START			0x0002
#define PVCSD_SDTOP_DMA_HALT			0x0004
#define PVCSD_SDTOP_DMA_CANCEL			0x0006
#define PVCSD_SDTOP_DMA_END				0x0008
#define PVCSD_SDTOP_DMA_STATUS			0x000A
#define PVCSD_SDTOP_DMA_SADR_L			0x0010
#define PVCSD_SDTOP_DMA_SADR_H_MMUID	0x0012
#define PVCSD_SDTOP_DMA_CNT				0x0014
#define PVCSD_SDTOP_DMA_BLK				0x0016
#define PVCSD_SDTOP_DMA_ADR_L			0x0018
#define PVCSD_SDTOP_DMA_ADR_H			0x001A
#define PVCSD_SDTOP_DMA_REMAIN_L		0x001C
#define PVCSD_SDTOP_DMA_REMAIN_H		0x001E
#define PVCSD_SDTOP_IRQ02_STATUS		0x0020
#define PVCSD_SDTOP_IRQ02_MASK_SET		0x0022
#define PVCSD_SDTOP_IRQ02_MASK_CLEAR	0x0024
#define PVCSD_SDTOP_MIC_CONFIG0			0x0026
#define PVCSD_SDTOP_MIC_CONFIG1			0x0028
#define PVCSD_SDTOP_DMA_CONFG0			0x002C
#define PVCSD_SDTOP_DMA_CONFG1			0x002E
#define PVCSD_SDTOP_SDCORE				0x0030
#define PVCSD_SDTOP_UHSIMODESEL			0x0032
#define PVCSD_SDTOP_TESTOUT_SEL			0x0034
#define PVCSD_SDTOP_RING_BADR_L			0x0036
#define PVCSD_SDTOP_RING_BADR_H_MMUID	0x0038
#define PVCSD_SDTOP_RING_BSIZE_L		0x003A
#define PVCSD_SDTOP_RING_BSIZE_H		0x003C
#define PVCSD_SDTOP_RING_TADR_L			0x003E
#define PVCSD_SDTOP_RING_TADR_H			0x0040
#define PVCSD_SDTOP_RING_TSIZE_L		0x0042
#define PVCSD_SDTOP_RING_TSIZE_H		0x0044
#define PVCSD_SDTOP_RING_RP_L			0x0046
#define PVCSD_SDTOP_RING_RP_H			0x0048

#define PVCSD_CMD			0x100
#define PVCSD_PORTSEL		0x102
#define PVCSD_ARG0			0x104
#define PVCSD_ARG1			0x106
#define PVCSD_STOP			0x108
#define PVCSD_SECCNT		0x10A
#define PVCSD_RSP0			0x10C
#define PVCSD_RSP1			0x10E
#define PVCSD_RSP2			0x110
#define PVCSD_RSP3			0x112
#define PVCSD_RSP4			0x114
#define PVCSD_RSP5			0x116
#define PVCSD_RSP6			0x118
#define PVCSD_RSP7			0x11A
#define PVCSD_INFO1			0x11C
#define PVCSD_INFO2			0x11E
#define PVCSD_INFO1_MASK	0x120
#define PVCSD_INFO2_MASK	0x122
#define PVCSD_CLK_CTRL		0x124
#define PVCSD_SIZE			0x126
#define PVCSD_OPTION		0x128
#define PVCSD_ERR_STS1		0x12C
#define PVCSD_ERR_STS2		0x12E
#define PVCSD_BUF0			0x130
#define PVCSD_SDIO_MODE		0x134
#define PVCSD_SDIO_INFO1	0x136
#define PVCSD_SDIO_INFO1_MASK	0x138
#define PVCSD_CC_EXT_MODE	0x1D8
#define PVCSD_SOFT_RST		0x1E0
#define PVCSD_VERSION		0x1E2
#define PVCSD_PWR			0x1F2
#define PVCSD_EXT_SDIO		0x1F4
#define PVCSD_EXT_WP		0x1F6
#define PVCSD_EXT_CD		0x1F8
#define PVCSD_EXT_CD_DAT3	0x1FA
#define PVCSD_EXT_CD_MASK	0x1FC
#define PVCSD_EXT_CD_DAT3_MASK	0x1FE

#define PVCSD_A2M_BASE		0x9F001000
#define PVCSD_A2M_MMUID0	0x200
#define PVCSD_A2M_MMUID1	0x204
#define PVCSD_A2M_MMUID2	0x208
#define PVCSD_A2M_MMUID3	0x20C
#define PVCSD_A2M_MONSEL	0x210
#define PVCSD_A2M_ST_MON0	0x214
#define PVCSD_A2M_ST_MON1	0x218
#define PVCSD_A2M_ST_MON2	0x21C
#define PVCSD_A2M_ST_MON3	0x220

#endif /* ifdef PVC01_SDIO_V9AHD */

#define PVCSD_CLOCKRATE_MAX	43875000

struct pvcsdio_platform_data {
	unsigned int clock;
};

#ifdef PVC01_SDIO_V9AHD

#define PVCSD_DM_CM_SEQ_REGSET  0x0800
#define PVCSD_DM_CM_SEQ_MODE 	0x0808
#define PVCSD_DM_CM_SEQ_CTRL 	0x0810
#define PVCSD_DM_CM_DTRAN_MODE  0x0820
#define PVCSD_DM_CM_DTRAN_CTRL  0x0828
#define PVCSD_DM_CM_RST			0x0830
#define PVCSD_DM_CM_INFO1		0x0840
#define PVCSD_DM_CM_INFO1_MASK	0x0848
#define PVCSD_DM_CM_INFO2		0x0850
#define PVCSD_DM_CM_INFO2_MASK  0x0858
#define PVCSD_DM_CM_TUNING_STAT 0x0860
#define PVCSD_DM_CM_SEQ_STAT 	0x0868
#define PVCSD_DM_DTRAN_ADDR		0x0880
#define PVCSD_DM_SEQ_CMD		0x08A0
#define PVCSD_DM_SEQ_ARG		0x08A8
#define PVCSD_DM_SEQ_SIZE		0x08B0
#define PVCSD_DM_SEQ_SECCNT		0x08B8
#define PVCSD_DM_SEQ_RSP		0x08C0
#define PVCSD_DM_SEQ_RSP_CHK	0x08C8
#define PVCSD_DM_SEQ_ADDR		0x08D0

/* DM_CM_DTRAN_MODE */
#define PVCSD_DM_CM_DTRAN_MODE_CH_NUM_DOWN		(0x00000000)		/* DMAC channel selector 00 : SD/UHS2 down stream */
#define PVCSD_DM_CM_DTRAN_MODE_CH_NUM_UP		(0x00010000)		/* DMAC channel selector 01 : SD/UHS2 up stream */
#define PVCSD_DM_CM_DTRAN_MODE_CH_NUM_MASK		(0x00030000)		/* DMAC channel selector Mask 10, 11:Donft set */
#define PVCSD_DM_CM_DTRAN_MODE_BUS_WIDTH_8BIT	(0x00000000)		/* Bus width selector 00: 8-bit */
#define PVCSD_DM_CM_DTRAN_MODE_BUS_WIDTH_16BIT	(0x00000010)		/* Bus width selector 01: 16-bit */
#define PVCSD_DM_CM_DTRAN_MODE_BUS_WIDTH_32BIT	(0x00000020)		/* Bus width selector 10: 32-bit */
#define PVCSD_DM_CM_DTRAN_MODE_BUS_WIDTH_64BIT	(0x00000030)		/* Bus width selector 11: 64-bit [default] */
#define PVCSD_DM_CM_DTRAN_MODE_BUS_WIDTH_MASK	(0x00000030)		/* Bus width selector mask */
#define PVCSD_DM_CM_DTRAN_MODE_ADDR_MODE		(0x00000001)		/* System address mode selector 0: fixed address 1: address increment */

/* DM_CM_DTRAN_CTRL */
#define PVCSD_DM_CM_DTRAN_CTRL_DM_SEL			(0x00000100)		/* Command type selector 0 : SD Legacy (UHS-I) command 1: UHS-II SD-TRAN command */
#define PVCSD_DM_CM_DTRAN_CTRL_DM_START			(0x00000001)		/* This bit triggers to start up DMAC. this bit to 1, SDIP operates DMAC transfer 		*/
																	/* for the channel set by DM_CM_DRAN_MODE.CH_NUM. SDIP clears this bit automatically, 	*/
																	/*when SDIP starts up DMAC.																*/

/* DM_CM_INFO1 */
#define PVCSD_DM_CM_INFO1_DTRAN_MASK			(0x000f0000)		/* Interrupt of DMAC data transfer completion DTRANEND[3:2] is reserved. */
#define PVCSD_DM_CM_INFO1_DTRAN_CH_DOWN			(0x00010000)		/* Interrupt of DMAC data transfer completion DTRANEND[0]: Channel0 */
#define PVCSD_DM_CM_INFO1_DTRAN_CH_UP			(0x00020000)		/* Interrupt of DMAC data transfer completion DTRANEND[1]: Channel1 */
#define PVCSD_DM_CM_INFO1_SEQ_SUSPEND			(0x00000100)		/* Interrupt of command sequencer process suspend */
#define PVCSD_DM_CM_INFO1_SEQEND				(0x00000001)		/* Interrupt of command sequencer process completion */

#else /* ifdef PVC01_SDIO_V9AHD */

#define PVCSD_DMA_MODE_DIR	0x0001
#define PVCSD_DMA_START		0x0001
#define PVCSD_DMA_END		0x0001
#define PVCSD_DMA_STATUS_START	0x0001
#define PVCSD_DMA_STATUS_CANCEL	0x0002
#define PVCSD_DMA_STATUS_END	0x0004
#define PVCSD_DMA_STATUS_HALT	0x0008
#define PVCSD_SET_IRQ2			0x0001
#endif /* ifdef PVC01_SDIO_V9AHD */

#endif	/* CONFIG_ARCH_UNIPHIER */

#endif	/* __ASM_ARCH_PVC01V_H */

