/*
 * arch/arm/mach-pvc01s/include/mach/pvc01v.h
 *
 * Copyright (c) 2012 Panasonic, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#ifndef __ASM_ARCH_PVC01V_H
#define __ASM_ARCH_PVC01V_H

#include <linux/autoconf.h>

#if defined(CONFIG_ARCH_UNIPHIER)

#define PVC01S_SDIO_V8FHD


#if defined(CONFIG_PVC01V_USE_SD0)
#define PVCSD_USE_SD0
#elif defined(CONFIG_PVC01V_USE_SD1)
#define PVCSD_USE_SD1
#endif

#if defined(CONFIG_PVC01V_USE_SD_PORT0)
#define PVCSD_USE_PORTSEL	0x0000
#elif defined(CONFIG_PVC01V_USE_SD_PORT1)
#define PVCSD_USE_PORTSEL	0x0001
#elif defined(CONFIG_PVC01V_USE_SD_PORT2)
#define PVCSD_USE_PORTSEL	0x0002
#elif defined(CONFIG_PVC01V_USE_SD_PORT3)
#define PVCSD_USE_PORTSEL	0x0003
#endif

#if defined(PVCSD_USE_SD0)
#define PVCSD_SDTOP_BASE	0x9C008000
#define PVCSD_SDTOP_SD_IRQ		0		//platform def
#define PVCSD_SDTOP_SDIO_IRQ	1		//platform def
#elif defined(PVCSD_USE_SD1)
#define PVCSD_SDTOP_BASE	0x9C001000
#define PVCSD_SDTOP_SD_IRQ		2		//platform def
#define PVCSD_SDTOP_SDIO_IRQ	3		//platform def
#endif
#define PVCSD_SDX_BASE		PVCSD_SDTOP_BASE

#define PVCSD_DMA_MODE_DIR	0x0001
#define PVCSD_DMA_START		0x0001
#define PVCSD_DMA_END		0x0001
#define PVCSD_DMA_STATUS_START	0x0001
#define PVCSD_DMA_STATUS_CANCEL	0x0002
#define PVCSD_DMA_STATUS_END	0x0004
#define PVCSD_DMA_STATUS_HALT	0x0008
#define PVCSD_SET_IRQ2			0x0001

#define PVCSD_SDTOP_DMA_MODE			0x0000
#define PVCSD_SDTOP_DMA_START			0x0002
#define PVCSD_SDTOP_DMA_HALT			0x0004
#define PVCSD_SDTOP_DMA_CANCEL			0x0006
#define PVCSD_SDTOP_DMA_END				0x0008
#define PVCSD_SDTOP_DMA_STATUS			0x000A
#define PVCSD_SDTOP_DMA_SADR_L			0x0010
#define PVCSD_SDTOP_DMA_SADR_H_MMUID	0x0012
#define PVCSD_SDTOP_DMA_CNT				0x0014
#define PVCSD_SDTOP_DMA_BLK				0x0016
#define PVCSD_SDTOP_DMA_ADR_L			0x0018
#define PVCSD_SDTOP_DMA_ADR_H			0x001A
#define PVCSD_SDTOP_DMA_REMAIN_L		0x001C
#define PVCSD_SDTOP_DMA_REMAIN_H		0x001E
#define PVCSD_SDTOP_IRQ02_STATUS		0x0020
#define PVCSD_SDTOP_IRQ02_MASK_SET		0x0022
#define PVCSD_SDTOP_IRQ02_MASK_CLEAR	0x0024
#define PVCSD_SDTOP_MIC_CONFIG0			0x0026
#define PVCSD_SDTOP_MIC_CONFIG1			0x0028
#define PVCSD_SDTOP_DMA_CONFG0			0x002C
#define PVCSD_SDTOP_DMA_CONFG1			0x002E
#define PVCSD_SDTOP_SDCORE				0x0030
#define PVCSD_SDTOP_UHSIMODESEL			0x0032
#define PVCSD_SDTOP_TESTOUT_SEL			0x0034
#define PVCSD_SDTOP_RING_BADR_L			0x0036
#define PVCSD_SDTOP_RING_BADR_H_MMUID	0x0038
#define PVCSD_SDTOP_RING_BSIZE_L		0x003A
#define PVCSD_SDTOP_RING_BSIZE_H		0x003C
#define PVCSD_SDTOP_RING_TADR_L			0x003E
#define PVCSD_SDTOP_RING_TADR_H			0x0040
#define PVCSD_SDTOP_RING_TSIZE_L		0x0042
#define PVCSD_SDTOP_RING_TSIZE_H		0x0044
#define PVCSD_SDTOP_RING_RP_L			0x0046
#define PVCSD_SDTOP_RING_RP_H			0x0048

#define PVCSD_CMD			0x100
#define PVCSD_PORTSEL		0x102
#define PVCSD_ARG0			0x104
#define PVCSD_ARG1			0x106
#define PVCSD_STOP			0x108
#define PVCSD_SECCNT		0x10A
#define PVCSD_RSP0			0x10C
#define PVCSD_RSP1			0x10E
#define PVCSD_RSP2			0x110
#define PVCSD_RSP3			0x112
#define PVCSD_RSP4			0x114
#define PVCSD_RSP5			0x116
#define PVCSD_RSP6			0x118
#define PVCSD_RSP7			0x11A
#define PVCSD_INFO1			0x11C
#define PVCSD_INFO2			0x11E
#define PVCSD_INFO1_MASK	0x120
#define PVCSD_INFO2_MASK	0x122
#define PVCSD_CLK_CTRL		0x124
#define PVCSD_SIZE			0x126
#define PVCSD_OPTION		0x128
#define PVCSD_ERR_STS1		0x12C
#define PVCSD_ERR_STS2		0x12E
#define PVCSD_BUF0			0x130
#define PVCSD_SDIO_MODE		0x134
#define PVCSD_SDIO_INFO1	0x136
#define PVCSD_SDIO_INFO1_MASK	0x138
#define PVCSD_CC_EXT_MODE	0x1D8
#define PVCSD_SOFT_RST		0x1E0
#define PVCSD_VERSION		0x1E2
#define PVCSD_PWR			0x1F2
#define PVCSD_EXT_SDIO		0x1F4
#define PVCSD_EXT_WP		0x1F6
#define PVCSD_EXT_CD		0x1F8
#define PVCSD_EXT_CD_DAT3	0x1FA
#define PVCSD_EXT_CD_MASK	0x1FC
#define PVCSD_EXT_CD_DAT3_MASK	0x1FE

#define PVCSD_A2M_BASE		0x9F001000
#define PVCSD_A2M_MMUID0	0x200
#define PVCSD_A2M_MMUID1	0x204
#define PVCSD_A2M_MMUID2	0x208
#define PVCSD_A2M_MMUID3	0x20C
#define PVCSD_A2M_MONSEL	0x210
#define PVCSD_A2M_ST_MON0	0x214
#define PVCSD_A2M_ST_MON1	0x218
#define PVCSD_A2M_ST_MON2	0x21C
#define PVCSD_A2M_ST_MON3	0x220

#define PVCSD_CLOCKRATE_MAX	43875000

struct pvcsdio_platform_data {
	unsigned int clock;
};

#endif	/* CONFIG_ARCH_UNIPHIER */

#endif	/* __ASM_ARCH_PVC01V_H */

