/**
 *  Copyright (C) 2012 Panasonic Corporation. All Rights Reserved.
 *
 * @file
 * @brief   CPU間通信D/DカーネルAPIヘッダー
 */

#ifndef ___ppcdev_h_included_
#define ___ppcdev_h_included_

#include <linux/interrupt.h>
#include "ppcdev_ioctl.h"

#define PPCDEV_SVETH_ID 0x10
#define PPCDEV_SDIO_ID  0x20

// カーネルAPI
int ppcdev_kopen( int id );
int ppcdev_kclose( int fd );
void *ppcdev_kmalloc( size_t size );
void ppcdev_kfree( const void *buf );
int ppcdev_ksend( int fd, int id, const void *buf, size_t size );
void ppcdev_kreqirq( int fd, irqreturn_t ( *ppcdev_irq_handler_t )( int, int, const void *, size_t ) );
int ppcdev_kioctl( int fd, unsigned int cmd, unsigned long arg );

#endif /* ___ppcdev_h_included_ */
