/**
 *  Copyright (C) 2012 Panasonic Corporation. All Rights Reserved.
 *
 * @file
 * @brief   CPU間通信D/D ioctlコマンドヘッダー
 */

#ifndef ___ppcdev_ioctl_h_included_
#define ___ppcdev_ioctl_h_included_

#include <linux/ioctl.h>

#define PPCDEV_IOCTL_MAGIC  0xAE

#define PPCDEV_IOCTL_IRQENABLE   _IOC( _IOC_NONE,  PPCDEV_IOCTL_MAGIC,  0, 0 )
#define PPCDEV_IOCTL_IRQDISABLE  _IOC( _IOC_NONE,  PPCDEV_IOCTL_MAGIC,  1, 0 )
#define PPCDEV_IOCTL_GETBLOCK    _IOC( _IOC_READ|_IOC_WRITE, PPCDEV_IOCTL_MAGIC,  6, sizeof( int )*3 )
#define PPCDEV_IOCTL_FREEBLOCK   _IOC( _IOC_NONE,  PPCDEV_IOCTL_MAGIC,  7, 0 )
#define PPCDEV_IOCTL_TXTMOUT     _IOC( _IOC_NONE,  PPCDEV_IOCTL_MAGIC,  8, 0 )
#define PPCDEV_IOCTL_RXTMOUT     _IOC( _IOC_NONE,  PPCDEV_IOCTL_MAGIC,  9, 0 )
#define PPCDEV_IOCTL_SETRETRY    _IOC( _IOC_NONE,  PPCDEV_IOCTL_MAGIC, 10, 0 )

#endif /* ___ppcdev_ioctl_h_included_ */
