
#ifndef _ICSMDRV_H_
#define _ICSMDRV_H_

/* A sleep time (tick) for when a memory block can not allocate */
#define ICSM_SLEEP_TIME		1

/* debug option */
/* #define ICSM_DEBUG */
#undef ICSM_DEBUG

#ifdef ICSM_DEBUG
#define ICSM_ABORT()	while(1)

#define ICSM_ASSERT(cond)	\
do {				\
	if (!(cond)) {		\
		ICSM_ABORT();	\
	}			\
} while (0)
#else
#define ICSM_ABORT()		do { } while (0)
#define ICSM_ASSERT(cond)	do { } while (0)
#endif

#include "icsm_def.h"
#include "icsm_if.h"

#if defined(ICC_LINUX)
#include "icc_hwd.h"
#include "icsmdrv_linux.h"
#elif defined(ICC_ITRON) || defined(ICC_OSLESS)
#include "icc_hwd.h"
#include "icsmdrv_itron.h"
#include "iccdrv.h"
#define icsm_context_check()	icc_context_check()
#endif

#if defined(__ICC_PVC01V__)
#if defined(ICC_ARM)
#include "icsmdrv_pvc01v_arm.h"
#elif defined(ICC_AM32)
#include "icsmdrv_pvc01v_am32.h"
#endif
#elif defined(__ICC_PVC02V__)
#include "icsmdrv_pvc02v.h"
#endif

extern int icsm_core_get_block(unsigned short memid, int timeout, icsm_block_t *sblock);
extern int icsm_core_free_block(icsm_block_t *sblock);

#endif /* _ICSMDRV_H_ */
