/*
 *  sveth.h
 *
 *	The virtual ethernet driver for the SPiCa movie system.
 *
 *  Copyright (C) 2012 Panasonic Corporation. All Rights Reserved.
 *
 */


#if !defined(_SVETH_H_)
#define _SVETH_H_

#include "sveth_debug.h"


#define _UHZ							(10)

#define _M2JIFFIES(_msec)				((_msec) * HZ / 1000)
#define _U2JIFFIES(_usec)				((_usec) * HZ / 1000000)


/* device info */
#define SVETH_DRV_DESC					"SPiCa virtual ethernet driver"
#define SVETH_DRV_VER					"0.01"

#define SVETH_DEV_NUM					(1)
#define SVETH_NETDEV_NAME				"eth"
#define SVETH_NDEV_NAME					SVETH_NETDEV_NAME"%d"


/* SK_BUFF padding */
#define SVETH_SKBUF_PADDING				(16)


/* packet info */
#define SVETH_MIN_PKTSIZE				(68)
#define SVETH_MAX_PKTSIZE				(1500)


/* IDs */
#define SVETH_ID_REQ_INT_STAT			(0x0154)
#define SVETH_ID_REQ_MAC_ADDR			(0x0155)

/* status flags */
#define SVETH_FLG_ALL					(0xFFFFFFFF)
#define SVETH_FLG_INIT					(0x00000001)
#define SVETH_FLG_QUIT					(0x00000002)
#define SVETH_FLG_SEND_PKT				(0x00000004)
#define SVETH_FLG_SET_INT_MODE			(0x00000008)
#define SVETH_FLG_SET_MAC_ADDR			(0x00000010)
#define SVETH_FLG_SET_POWER_MODE		(0x00000020)
#define SVETH_FLG_SET_MCAST_MODE		(0x00000040)
#define SVETH_FLG_SET_WOL_MODE			(0x00000080)
#define SVETH_FLG_REQ_INT_STAT			(0x00000100)
#define SVETH_FLG_REQ_MAC_ADDR			(0x00000200)
#define SVETH_FLG_REQ_LINK_STAT			(0x00000400)
#define SVETH_FLG_NOTIFY_STAT			(0x00000800)


#endif	/* _SVETH_H_ */

