/*
 *  sveth_config.h
 *
 *	The virtual ethernet driver for the SPiCa movie system.
 *
 *  Copyright (C) 2012 Panasonic Corporation. All Rights Reserved.
 *
 */

#ifndef __SVETH_CONFIG_H_
#define __SVETH_CONFIG_H_


/**
 *	[for local definitions]
 */


#if 1
#define SVETH_DEFAULT_MAC_ADDR			{0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF}
#else
#define SVETH_DEFAULT_MAC_ADDR			{0x00, 0x0B, 0x97, 0x76, 0x40, 0x00}
#endif

/* Default timeout period */
#define SVETH_TIMEOUT					_M2JIFFIES(0)			/* use default */

/* for mpool */
#define SVETH_TX_EXPIRED				_M2JIFFIES(0)			/* infinity */
#define SVETH_RX_EXPIRED				_M2JIFFIES(0)			/* infinity */

/* for tx_pkt */
#define SVETH_TX_REQ_EXPIRED			_M2JIFFIES(0)			/* infinity */

/* for rx_pkt */
#define SVETH_RX_REQ_EXPIRED			_M2JIFFIES(0)			/* infinity */

/* for Tx done */
#define SVETH_CHECK_EVENT_POLLING		100						/* 100usec */
#define SVETH_CHECK_EVENT_SCHED			_M2JIFFIES(10)			/* call scheduler (every 10msec) */
#define SVETH_TX_DONE_CHECK_EXPIRED		_M2JIFFIES(0)			/* infinity */


/* timeout value */
#define SVETH_INIT_TO					_M2JIFFIES(500)		/* 500msec */
#define SVETH_QUIT_TO					_M2JIFFIES(500)		/* 500msec */
#define SVETH_REQ_INT_STAT_TO			_M2JIFFIES(500)		/* 500msec */
#define SVETH_REQ_MAC_ADDR_TO			_M2JIFFIES(500)		/* 500msec */
#define SVETH_REQ_LINK_STAT_TO			_M2JIFFIES(500)		/* 500msec */


#endif	/* __SVETH_CONFIG_H_ */

