/*
 * Copyright (C) 2011, Panasonic Corporation.
 *                       All Rights Reserved.
 *
 */

#if defined(CONFIG_USB_PANASONIC_BP3)

/*_ ե֥å _*/
static inline void internal_host_peripheryhw_init( void )
{

	u32 tmp;

	/*_ host0 _*/
	
	/*_ MIO_USBRSTCTRL USBꥻåȲ _*/
	writel( 0x00000001, (void*)0xD9810114 );	/*_ host0 _*/

	/*_ MIO_RSTCTRL0 UBRGRST(bit 24)ꥻåȲ _*/
	tmp = readl((void*)0xD9810110);		/*_ host0 _*/
	tmp |= 0x01000000;
	writel( tmp, (void*)0xD9810110 );


#ifndef CONFIG_USB_PANASONIC_SINGLE_HOST
	/*_ host1 _*/

	/*_ MIO_USBRSTCTRL USBꥻåȲ _*/
	writel( 0x00000001, (void*)0xD9810314 );	/*_ host1 _*/

	/*_ MIO_RSTCTRL1 UBRG1RST(bit 24)ꥻåȲ _*/
	tmp = readl((void*)0xD9810310);		/*_ host1 _*/
	tmp |= 0x01000000;
	writel( tmp, (void*)0xD9810310 );

#endif /*_ CONFIG_USB_PANASONIC_SINGLE_HOST _*/
	
}



/*_------------------------------------------------------------------------
	EHCIۥȴϢޥ
------------------------------------------------------------------------_*/
#define INTERNAL_EHCI_BASE_ADR_0      (0xDA800000)    /*_ host0 EHCI Base Address	_*/
#define INTERNAL_EHCI_IRQ_NUM_0       (116)           /*_ host0 EHCI IRQ NUM		_*/
#define INTERNAL_EHCI_BASE_ADR_1      (0xDA810000)    /*_ host1 EHCI Base Address	_*/
#define INTERNAL_EHCI_IRQ_NUM_1       (130)           /*_ host1 EHCI IRQ NUM		_*/

#define USBH_EHCI_BURSTSIZE         (0x00008080)    /*_  BURSTSIZE _*/
#define USBH_EHCI_TXFILLTUNING      (0x00020000)    /*_  TXFILLTUNING _*/
#define INTERNAL_EHCI_MEM_LEN       (0x200)         /*_  EHCI core region _*/
#define INTERNAL_EHCI_CAPS_BASE     (0x0100)        /*_  EHCI CAPS BASE _*/
#define INTERNAL_EHCI_REGS_BASE     (0x0140)        /*_  EHCI REGS BASE _*/
#define USBH_IOBASEADDR       		(0x0)			/*_  IO Base Address _*/


/*_ USBۥ ꥽¤ _*/
static const struct resource host_res[][2] = {
	{/*_  host #0 _*/
		{
			.start	= INTERNAL_EHCI_BASE_ADR_0,
			.end	= INTERNAL_EHCI_BASE_ADR_0 + INTERNAL_EHCI_MEM_LEN - 1,
			.flags	= IORESOURCE_MEM,
		}, {
			.start	= INTERNAL_EHCI_IRQ_NUM_0,
			.flags	= IORESOURCE_IRQ,
		},
	},

#ifndef CONFIG_USB_PANASONIC_SINGLE_HOST
	{/*_  host #1 _*/
		{
			.start	= INTERNAL_EHCI_BASE_ADR_1,
			.end	= INTERNAL_EHCI_BASE_ADR_1 + INTERNAL_EHCI_MEM_LEN - 1,
			.flags	= IORESOURCE_MEM,
		}, {
			.start	= INTERNAL_EHCI_IRQ_NUM_1,
			.flags	= IORESOURCE_IRQ,
		},
	},
#endif /*_ CONFIG_USB_PANASONIC_SINGLE_HOST _*/
	
};



#ifdef CONFIG_USB_PANASONIC_HOST_INTRMEM
/*_------------------------------------------------------------------------
	EHCI ¢
------------------------------------------------------------------------_*/
#define INTERMEM_SIZE	16384		/*_ ¢ǻѲǽʥ 	_*/
#define INTERMEM_OFFSET	0x4000		/*_ EHCIΥ쥸Υեå 		_*/

typedef struct _INTERMEM_CONFIG{	/*_ ¢ס롢쥰롼ʬ _*/
	int size;						/*_ ΡɤΥ 	_*/
	int num;						/*_ Ρɤο 		_*/
} INTERMEM_CONFIG;

static const INTERMEM_CONFIG intermem_configuration[]={
	{	1024,	2},					/*_ periodicǻѤ롣ڡ֤ʤưʤ _*/
	{	128,	112},				/*_ qhǻѤ _*/
};
#endif	/*_ CONFIG_USB_PANASONIC_HOST_INTRMEM _*/


#endif /* CONFIG_USB_PANASONIC_BP3 */

