/*
 * Copyright (C) 2012, Panasonic Corporation 
 */

#if defined(CONFIG_USB_PANASONIC_PRO4R)

#ifdef CONFIG_USB_IGNORE_CERR
static u8	usb_target = 1;
#endif

/*_------------------------------------------------------------------------
	PHY쥸ޥ
------------------------------------------------------------------------_*/
#define EHCI_USBPHY1_CTRL_REG     (0xdF800500)    /*_  PHY1 set register             _*/
#define EHCI_USBPHY1_CTRL2_REG    (0xdF800504)    /*_  PHY1 set register             _*/
#define EHCI_USBPHY2_CTRL_REG     (0xdF800508)    /*_  PHY2 set register             _*/
#define EHCI_USBPHY2_CTRL2_REG    (0xdF80050C)    /*_  PHY2 set register             _*/

/*_ ե֥å _*/
static inline void internal_host_peripheryhw_init( void )
{
	/*_ ꥻåȲ _*/
	outl( 0x00000001, 0x59810114 );	/*_ usb0 _*/
	outl( 0x00000001, 0x59810314 );	/*_ usb1 _*/

	/*_ HS PHY _*/
	writel( 0x05142400, (void*)EHCI_USBPHY1_CTRL_REG );	/*_PHY1 _*/
	writel( 0x00000007, (void*)EHCI_USBPHY1_CTRL2_REG );	/*_PHY1 _*/
	writel( 0x05142400, (void*)EHCI_USBPHY2_CTRL_REG );	/*_PHY2 _*/
	writel( 0x00010010, (void*)EHCI_USBPHY2_CTRL2_REG );	/*_PHY2 _*/

}

/*_------------------------------------------------------------------------
	EHCIۥȴϢޥ
------------------------------------------------------------------------_*/
#define INTERNAL_EHCI_BASE_ADR_0	(0xDA800000)	/*_  host #0 EHCI Base Address _*/
#define INTERNAL_EHCI_IRQ_NUM_0		(112)			/*_  host #0 EHCI IRQ NUM _*/
#define INTERNAL_EHCI_BASE_ADR_1	(0xDA810000)	/*_  host #1 EHCI Base Address _*/
#define INTERNAL_EHCI_IRQ_NUM_1		(113)			/*_  host #1 EHCI IRQ NUM _*/

#define USBH_EHCI_BURSTSIZE         (0x00004080)    /*_  BURSTSIZE _*/
#define USBH_EHCI_TXFILLTUNING      (0x00020000)    /*_  TXFILLTUNING _*/
#define INTERNAL_EHCI_MEM_LEN       (0x200)         /*_  EHCI core region _*/
#define INTERNAL_EHCI_CAPS_BASE     (0x0100)        /*_  EHCI CAPS BASE _*/
#define INTERNAL_EHCI_REGS_BASE     (0x0140)        /*_  EHCI REGS BASE _*/
#define USBH_IOBASEADDR       		(0x0)			/*_  IO Base Address _*/


/*_ USBۥ ꥽¤ _*/
static const struct resource host_res[][2] = {
	{/*_  host #0 _*/
		{
			.start	= INTERNAL_EHCI_BASE_ADR_0,
			.end	= INTERNAL_EHCI_BASE_ADR_0 + INTERNAL_EHCI_MEM_LEN - 1,
			.flags	= IORESOURCE_MEM,
		}, {
			.start	= INTERNAL_EHCI_IRQ_NUM_0,
			.flags	= IORESOURCE_IRQ,
		},
	},
	{/*_  host #1 _*/
		{
			.start	= INTERNAL_EHCI_BASE_ADR_1,
			.end	= INTERNAL_EHCI_BASE_ADR_1 + INTERNAL_EHCI_MEM_LEN - 1,
			.flags	= IORESOURCE_MEM,
		}, {
			.start	= INTERNAL_EHCI_IRQ_NUM_1,
			.flags	= IORESOURCE_IRQ,
		},
	},
};



#ifdef CONFIG_USB_PANASONIC_HOST_INTRMEM
/*_------------------------------------------------------------------------
	EHCI ¢
------------------------------------------------------------------------_*/
#define INTERMEM_SIZE	16384		/*_ ¢ǻѲǽʥ _*/
#define INTERMEM_OFFSET	0x4000		/*_ EHCIΥ쥸Υեå _*/

typedef struct _INTERMEM_CONFIG{	/*_ ¢ס롢쥰롼ʬ _*/
	int size;						/*_ ΡɤΥ _*/
	int num;						/*_ Ρɤο _*/
} INTERMEM_CONFIG;

static const INTERMEM_CONFIG intermem_configuration[]={
	{	2048,	1},					/*_ periodicǻѤ롣ڡ֤ʤưʤ _*/
	{	128,	112},				/*_ qhǻѤ _*/
};
#endif	/*_ CONFIG_USB_PANASONIC_HOST_INTRMEM _*/

#endif /* CONFIG_USB_PANASONIC_PRO4R */

