/*
 * Copyright (C) 2010, Panasonic Corporation 
 */

#if defined(CONFIG_USB_PANASONIC_SLD2H)

/*_ ե֥å _*/
static inline void internal_host_peripheryhw_init( void )
{
	/*_ ꥻåȲ _*/
	outl( 0x00000001, 0x59810114 );	/*_ usb0 _*/
	outl( 0x00000001, 0x59810314 );	/*_ usb1 _*/
	outl( 0x00000001, 0x59810514 );	/*_ usb2 _*/
	
	/*_ MIO_SYSTEM_MODECTRL(IObus Endian : ȥ륨ǥ) _*/
	outl( 0x00010000, 0x59810030 );	/*_ usb0 _*/
	outl( 0x00010000, 0x59810230 );	/*_ usb1 _*/
	outl( 0x00010000, 0x59810430 );	/*_ usb2 _*/
	
	/*_ FileDMAC _*/
	outl( 0x00001100, 0x5A000030 );	/*_ usb0 _*/
	outl( 0x00001100, 0x5A010010 );	/*_ usb1 _*/
	outl( 0x00001100, 0x5A010030 );	/*_ usb2 _*/
}

/*_------------------------------------------------------------------------
	EHCIۥȴϢޥ
------------------------------------------------------------------------_*/
#define INTERNAL_EHCI_BASE_ADR_0	(0x5A800000)	/*_  host #0 EHCI Base Address _*/
#define INTERNAL_EHCI_IRQ_NUM_0		(116)			/*_  host #0 EHCI IRQ NUM _*/
#define INTERNAL_EHCI_BASE_ADR_1	(0x5A810000)	/*_  host #1 EHCI Base Address _*/
#define INTERNAL_EHCI_IRQ_NUM_1		(130)			/*_  host #1 EHCI IRQ NUM _*/
#define INTERNAL_EHCI_BASE_ADR_2	(0x5A820000)	/*_  host #2 EHCI Base Address _*/
#define INTERNAL_EHCI_IRQ_NUM_2		(614)			/*_  host #2 EHCI IRQ NUM _*/

#define USBH_EHCI_BURSTSIZE         (0x00004080)    /*_  BURSTSIZE _*/
#define USBH_EHCI_TXFILLTUNING      (0x00020000)    /*_  TXFILLTUNING _*/
#define INTERNAL_EHCI_MEM_LEN       (0x200)         /*_  EHCI core region _*/
#define INTERNAL_EHCI_CAPS_BASE     (0x0100)        /*_  EHCI CAPS BASE _*/
#define INTERNAL_EHCI_REGS_BASE     (0x0140)        /*_  EHCI REGS BASE _*/
#define USBH_IOBASEADDR       		(0x0)			/*_  IO Base Address _*/


/*_ USBۥ ꥽¤ _*/
static const struct resource host_res[][2] = {
	{/*_  host #0 _*/
		{
			.start	= INTERNAL_EHCI_BASE_ADR_0,
			.end	= INTERNAL_EHCI_BASE_ADR_0 + INTERNAL_EHCI_MEM_LEN - 1,
			.flags	= IORESOURCE_MEM,
		}, {
			.start	= INTERNAL_EHCI_IRQ_NUM_0,
			.flags	= IORESOURCE_IRQ,
		},
	},
	{/*_  host #1 _*/
		{
			.start	= INTERNAL_EHCI_BASE_ADR_1,
			.end	= INTERNAL_EHCI_BASE_ADR_1 + INTERNAL_EHCI_MEM_LEN - 1,
			.flags	= IORESOURCE_MEM,
		}, {
			.start	= INTERNAL_EHCI_IRQ_NUM_1,
			.flags	= IORESOURCE_IRQ,
		},
	},
	{/*_  host #2 _*/
		{
			.start	= INTERNAL_EHCI_BASE_ADR_2,
			.end	= INTERNAL_EHCI_BASE_ADR_2 + INTERNAL_EHCI_MEM_LEN - 1,
			.flags	= IORESOURCE_MEM,
		}, {
			.start	= INTERNAL_EHCI_IRQ_NUM_2,
			.flags	= IORESOURCE_IRQ,
		},
	},
};



#ifdef CONFIG_USB_PANASONIC_HOST_INTRMEM
/*_------------------------------------------------------------------------
	EHCI ¢
------------------------------------------------------------------------_*/
#define INTERMEM_SIZE	8192		/*_ ¢ǻѲǽʥ _*/
#define INTERMEM_OFFSET	0x2000		/*_ EHCIΥ쥸Υեå _*/

typedef struct _INTERMEM_CONFIG{	/*_ ¢ס롢쥰롼ʬ _*/
	int size;						/*_ ΡɤΥ _*/
	int num;						/*_ Ρɤο _*/
} INTERMEM_CONFIG;

static const INTERMEM_CONFIG intermem_configuration[]={
	{	1024,	2},					/*_ periodicǻѤ롣ڡ֤ʤưʤ _*/
	{	128,	48},				/*_ qhǻѤ _*/
};
#endif	/*_ CONFIG_USB_PANASONIC_HOST_INTRMEM _*/

#endif /* CONFIG_USB_PANASONIC_SLD2H */

