
#ifndef _ICC_CFG_H_
#define _ICC_CFG_H_

/*****************************************************************************
 * Inter CPU Communication Configration File
 *****************************************************************************/

/***** ICC FIFO definitions *****/
/* FIFO address */
#define ICC_CB_TOP_ADDR	0x8D9E9800

/* FIFO length */
#define CPU0_1_FIFO_LEN	0x10	//gp
#define CPU0_2_FIFO_LEN	0x2E0
#define CPU0_3_FIFO_LEN	0x10	//gp

#define CPU1_0_FIFO_LEN	0x10	//gp
#define CPU1_2_FIFO_LEN	0x10	//gp
#define CPU1_3_FIFO_LEN	0x10	//gp

#define CPU2_0_FIFO_LEN	0x2E0
#define CPU2_1_FIFO_LEN	0x10	//gp
#define CPU2_3_FIFO_LEN	0x10	//gp

#define CPU3_0_FIFO_LEN	0x10	//gp
#define CPU3_1_FIFO_LEN	0x10	//gp
#define CPU3_2_FIFO_LEN	0x10	//gp

/* ID Max number (each CPU) */
#define ICC_CPU_ID_MAX			15

/* Max message length (byte) */
#define ICC_MESSAGE_MAX_LEN		128

/***** ICC driver options *****/
/* Message pending mode
 *   mode of the write destination id is not ready.
 *   0: the write function returns error.
 *   1: a message is pending in the buffer.
 */
#define ICC_MESSAGE_PENDING_MODE	1

/*****************************************************************************/
/***** ICC id definitions *****/

/* ID for CPU0 */
enum {
	ICC_CPU0_BASE_ID = 0,		/* Don't edit this value */
	/* Please add ICC ID definitions */

	CPU0_NET_EVENT_ID,			/* Net event msg "NET  -> BE"  */
	CPU0_USB_HOST_ID,			/* Usbh event msg "USBH -> BE" */
};

/* ID for CPU1 */
enum {
	ICC_CPU1_BASE_ID = 0x4000,	/* Don't edit this value */
	/* Please add ICC ID definitions */

};

/* ID for CPU2 */
enum {
	ICC_CPU2_BASE_ID = 0x8000,	/* Don't edit this value */
	/* Please add ICC ID definitions */

 	CPU2_NET_EVENT_ID,			/* Net event msg "BE -> NET"   */
	CPU2_USB_HOST_ID,			/* Usbh event msg "BE -> USBH" */

};

/* ID for CPU3 */
enum {
	ICC_CPU3_BASE_ID = 0xc000,	/* Don't edit this value */
	/* Please add ICC ID definitions */


};

/*****************************************************************************/
/* Don't edit the following line. */
#define ICC_BASECB_LEN		(sizeof(icc_basecb_t)) /* It depends on the config for ICC_CPU_ID_MAX */
#define ICC_FIFOCB_LEN		(sizeof(icc_fifocb_t) + sizeof(icc_packetcb_t) + 4) /* 0x10 */

#define CPU0_1_FIFO_ADDR	(ICC_CB_TOP_ADDR + ICC_BASECB_LEN)
#define CPU0_2_FIFO_ADDR	(CPU0_1_FIFO_ADDR + CPU0_1_FIFO_LEN)
#define CPU0_3_FIFO_ADDR	(CPU0_2_FIFO_ADDR + CPU0_2_FIFO_LEN)

#define CPU1_0_FIFO_ADDR	(CPU0_3_FIFO_ADDR + CPU0_3_FIFO_LEN)
#define CPU1_2_FIFO_ADDR	(CPU1_0_FIFO_ADDR + CPU1_0_FIFO_LEN)
#define CPU1_3_FIFO_ADDR	(CPU1_2_FIFO_ADDR + CPU1_2_FIFO_LEN)

#define CPU2_0_FIFO_ADDR	(CPU1_3_FIFO_ADDR + CPU1_3_FIFO_LEN)
#define CPU2_1_FIFO_ADDR	(CPU2_0_FIFO_ADDR + CPU2_0_FIFO_LEN)
#define CPU2_3_FIFO_ADDR	(CPU2_1_FIFO_ADDR + CPU2_1_FIFO_LEN)

#define CPU3_0_FIFO_ADDR	(CPU2_3_FIFO_ADDR + CPU2_3_FIFO_LEN)
#define CPU3_1_FIFO_ADDR	(CPU3_0_FIFO_ADDR + CPU3_0_FIFO_LEN)
#define CPU3_2_FIFO_ADDR	(CPU3_1_FIFO_ADDR + CPU3_1_FIFO_LEN)

#define ICC_FIFO_BOTTOM_ADDR	(CPU3_2_FIFO_ADDR + CPU3_2_FIFO_LEN)

#endif /* _ICC_CFG_H_ */
