
#ifndef _ICC_HWD_PVC02V_H_
#define _ICC_HWD_PVC02V_H_

/***********************************************************/

/* ICC receive interrupt ID definition */
#define ICC_CPU0_IRQ	2
#define ICC_CPU1_IRQ	2
#define ICC_CPU2_IRQ	2
#define ICC_CPU3_IRQ	2


/***********************************************************/
/*     !! Don't modify or delete the following line !!     */
/***********************************************************/
#ifndef __ICC_PVC02V__
#define __ICC_PVC02V__
#endif
/***********************************************************/
#if defined(ICC_ARM)
/* GIC definitions */
#if !defined(__ICC_PVC02V_V2P__) /* V9 */
#define _ICC_GIC_START		0x70000000
#define _ICC_GIC_SIZE		0x00020000
#define GIC_PERCPU_OFFSET	0x00008000
#define GIC_CPU_IF_BASE		(_ICC_GIC_START + 0x2000)
#define GIC_DIST_BASE		(_ICC_GIC_START + 0x1000)
#else
#define _ICC_GIC_START		0x2c000000
#define _ICC_GIC_SIZE		0x00008000
#define GIC_PERCPU_OFFSET	0x00000000
#define GIC_CPU_IF_BASE		(_ICC_GIC_START + 0x2000)
#define GIC_DIST_BASE		(_ICC_GIC_START + 0x1000)
#endif

#define GIC_CPU_IF_EOI		0x10
#define GIC_DIST_ISER		0x100
#define GIC_DIST_ICPR		0x280
#define GIC_DIST_ABR		0x300
#define GIC_DIST_SGIR		0xf00
#define GIC_DIST_CPENDSGIR	0xf10

/* Receive irq definitions */
/* Linux request_irq */
#if defined(ICC_ON_CPU0)
#define ICC_RCV_IRQ	ICC_CPU0_IRQ
#elif defined(ICC_ON_CPU1)
#define ICC_RCV_IRQ	ICC_CPU1_IRQ
#elif defined(ICC_ON_CPU2)
#define ICC_RCV_IRQ	ICC_CPU2_IRQ
#elif defined(ICC_ON_CPU3)
#define ICC_RCV_IRQ	ICC_CPU3_IRQ
#endif
#define ICCDRV_RECV_IRQ		{ICC_RCV_IRQ, -1}

/* Linux ioremap address definitions */
#define _ICC_MAP0_START	(ICC_CB_TOP_ADDR & PAGE_MASK)
#define _ICC_MAP0_END	(PAGE_ALIGN(ICC_FIFO_BOTTOM_ADDR))
#define _ICC_MAP0_SIZE	(_ICC_MAP0_END - _ICC_MAP0_START)

#define ICCDRV_IOMAP_REGION	{			\
	/* {vaddr, paddr, size} */ 			\
	{0, _ICC_MAP0_START, _ICC_MAP0_SIZE},		\
	{0, _ICC_GIC_START, _ICC_GIC_SIZE},		\
	{0, 0, 0}					\
}

/* Linux ICSM ioremap address definitions */
#define _ICSM_MAP0_START	(ICSM_CB_TOP_ADDR & PAGE_MASK)
#define _ICSM_MAP0_SIZE		(2 * PAGE_SIZE)

#define ICSMDRV_IOMAP_REGION	{			\
	/* {vaddr, paddr, size} */			\
	{0, _ICSM_MAP0_START, _ICSM_MAP0_SIZE}, 	\
	{0, 0, -1}					\
}

#endif /* ICC_ARM */
/***********************************************************/
#endif /* _ICC_HWD_PVC02V_H_ */
