
#ifndef _ICC_IF_H_
#define _ICC_IF_H_

/* The error code definitions */
#define ICC_E_PAR	-1
#define ICC_E_CTX	-2
#define ICC_E_BUSY	-3
#define ICC_E_NOLINK	-4
#define ICC_E_SYS	-5
#define ICC_E_NOMEM	-6
#define ICC_E_NODATA	-7
#define ICC_E_FAULT	-8

/* The timeout parameter definitions */
#define ICC_FOREVER	-1


#if defined(ICC_LINUX)
/* For ioctl definitions */
#include <linux/ioctl.h>
typedef struct icc_ctrl_struct {
	unsigned short id;
	unsigned int flags;
} icc_ctrl_t;

#define ICC_IOC_MAGIC			0x5c
#define ICC_IOC_SET_READ_TMOUT		_IO(ICC_IOC_MAGIC, 1)
#define ICC_IOC_SET_WRITE_TMOUT		_IO(ICC_IOC_MAGIC, 2)
#define ICC_IOC_IS_SELF_ID		_IOWR(ICC_IOC_MAGIC, 3, icc_ctrl_t)
// add 2014.08.04 AVCMMS --->
#define ICC_IOC_LINUX_SLEEP		_IO(ICC_IOC_MAGIC, 4)
// <--- add 2014.08.04 AVCMMS

/*
 *  Minor devices for Linux:
 *     /dev/icc0
 *      -- for system (reserved)
 *     /dev/icc1 ... /dev/icc{ICC_CPU_ID_MAX}
 *      -- for users
 */
#define ICC_MINOR_NUM		(ICC_CPU_ID_MAX + 1)

#endif /* ICC_LINUX */

#endif /* _ICC_IF_H_ */
