
#ifndef _ICSM_CFG_H_
#define _ICSM_CFG_H_

/*****************************************************************************
 * Inter CPU Shared Memory Configration File
 *****************************************************************************/

#define ICSM_CB_TOP_ADDR	0x8D9F0000

#define ICSM_SHARE_MEM_ADDR	0x8D9F1000


/* Inter CPU Shared Memory Block definitions */
enum {
	/* Please add ICSM ID definitions */
	ICSM_BE2NET_BLOCK,		/* BE --> NET */
	ICSM_NET2BE_BLOCK,		/* NET --> BE */
	

	/* Don't delete a following line */
	ICSM_MEMBLK_MAX
};


#ifdef ICSM_INIT_BLOCK_DEFINE
typedef struct icsm_info_struct {
	int id;
	unsigned long maddr;
	int blklen;
	int blknum;
} icsm_info_t;

const icsm_info_t icsm_info[] = {
	/* Please add ICSM block information */
	{
		/* .id     = */ ICSM_BE2NET_BLOCK,
		/* .maddr  = */ ICSM_SHARE_MEM_ADDR,
		/* .blklen = */ 0x200,
		/* .blknum = */ 8
	},
	{
		/* .id     = */ ICSM_NET2BE_BLOCK,
		/* .maddr  = */ 0,
		/* .blklen = */ 0x200,
		/* .blknum = */ 8
	}
};
#endif /* ICSM_INIT_BLOCK_DEFINE */

#endif /* _ICSM_CFG_H_ */
