#ifndef _ICSMDEF_H_
#define _ICSMDEF_H_

#include "icsm_cfg.h"

#define ICSM_VER_MAJOR		1
#define ICSM_VER_MINOR		2
#define ICSM_VER_RELEASE	2

#define ICSM_VERSION_DEFINE(a, b, c)	\
	(((a) << 12) | ((b) << 6) | ((c) << 0))

#define ICSM_VERSION	\
	ICSM_VERSION_DEFINE(ICSM_VER_MAJOR, ICSM_VER_MINOR, ICSM_VER_RELEASE)

#if defined(ICC_LINUX)
#ifdef __KERNEL__
#include <linux/types.h>
#else
#include <stdint.h>
#endif
#else /* !ICC_LINUX */
#ifndef _icc_icsm_typedef_
#define _icc_icsm_typedef_
typedef unsigned char	uint8_t;
typedef unsigned short	uint16_t;
typedef unsigned int	uint32_t;
#endif
#ifndef NULL
#define NULL	0
#endif
#endif /* !ICC_LINUX */

#if defined(__CC__)
#ifndef inline
#define inline
#endif
#elif defined(__CC_ARM)
#ifndef inline
#define inline __inline
#endif
#endif

typedef struct icsm_basecb {
	uint16_t version;
	uint8_t lock;
	uint8_t reserved;
	uint32_t length;
} icsm_basecb_t;

typedef struct icsm_blkcb {
	uint32_t topaddr;
	uint32_t blklen;
	uint32_t blknum;
	/* uint32_t blkmap[] */
} icsm_blkcb_t;

#define ICSM_BLKCB_BITMAP(blkcb, index)				\
	(*(volatile uint32_t *)((unsigned long)(blkcb) +	\
				sizeof(icsm_blkcb_t) +		\
				sizeof(uint32_t) * (index)))

/* ICSM_BLKCB_MAP return bitmap (&blkcb->blkmap[index]) */

#endif /* _ICSMDEF_H_ */
