
#ifndef _ICSM_IF_H_
#define _ICSM_IF_H_

/* The error code definitions */
#define ICSM_E_PAR	-1
#define ICSM_E_CTX	-2
#define ICSM_E_BUSY	-3
#define ICSM_E_NOMEM	-4
#define ICSM_E_SYS	-5
#define ICSM_E_FAULT	-6

/* The timeout parameter definitions */
#define ICSM_FOREVER	-1

/* icsm block definition */
typedef struct icsm_block_struct {
	unsigned short memid;	/* memory pool ID */
	void	*maddr;		/* shared memory address (MCU MMU adress) */
	int	length;		/* memory block length */
	int	flags;		/* mapping cache mode (for Linux) */
	void	*vaddr;		/* virtual address (for Linux) */
} icsm_block_t;

/* The mapping attribute definitions */
#define ICSM_UNCACHE	0x20000000
#define ICSM_WRITEBACK	0x80000000

/* file descriptor definitions */
typedef struct icsm_fd {
	int memfd;
	int ucmemfd;
	int icsmfd;
} icsm_fd_t;

#if defined(ICC_LINUX)
/* For ioctl definitions */
#include <linux/ioctl.h>
typedef struct icsm_ctrl_struct {
	unsigned short memid;
	int timeout;
} icsm_ctrl_t;

#define ICSM_IOC_MAGIC			0x5d
#define ICSM_IOC_GET_BLOCK		_IOWR(ICSM_IOC_MAGIC, 1, icsm_block_t)
#define ICSM_IOC_FREE_BLOCK		_IOW(ICSM_IOC_MAGIC,  2, icsm_block_t)
#define ICSM_IOC_GET_PADDR		_IOR(ICSM_IOC_MAGIC,  3, icsm_block_t)
#define ICSM_IOC_SET_TIMEOUT		_IOW(ICSM_IOC_MAGIC,  4, icsm_ctrl_t)
#endif /* ICC_LINUX */

#endif /* _ICSM_IF_H_ */
