/* MN2PS On-chip serial port driver definitions
 *
 * Copyright (C) 2012 Panasonic Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public Licence
 * as published by the Free Software Foundation; either version
 * 2 of the Licence, or (at your option) any later version.
 */
#ifndef _LINUX_SERIAL_MN2PS_H
#define _LINUX_SERIAL_MN2PS_H

/* termios c_cflag definition */
#define CODMSB  004000000000    /* change Transfer bit-order */

/* ioctl command definition */
#define TIOSSGET        0x5460
#define TIOSSSET        0x5461
#define TIOPGET         0x5462
#define TIOPSET         0x5463
#define TIODLGET        0x5464
#define TIODLSET        0x5465

/* select serial protocol */
#define PROTOCOL_ASYNC  0       /* start-stop transmission              */
#define PROTOCOL_SYNC   1       /* clock synchronized transmission      */

/* Information of transfer rate of the synchronous serial */
struct mn2ps_serial_sync_speed {
  unsigned char   clk_src;
  unsigned char   exclk_sel;
  unsigned int    prescaler_cycle;
};

#define  CLK_SRC_SBT            00    /* SBT clock                     */
#define  CLK_SRC_2              01    /* 1/2 cycle of exclk underflow  */
#define  CLK_SRC_16             03    /* 1/16 cycle of exclk underflow */

#define  EXCLK_PERI             03    /* exclk = ca9_peri clock  */
#define  EXCLK_PRESCALER        02    /* exclk = prescaler timer */

#endif /* _LINUX_SERIAL_MN2PS_H */
